<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelDecontosTipoConsumi  {

    protected $RelDecontosTipoConsumiService;
    protected $utilService;
    
    public function __construct(Services\RelDecontosTipoConsumiService $RelDecontosTipoConsumiService, Utilities\Util $utilService) {
        $this->RelDecontosTipoConsumiService = $RelDecontosTipoConsumiService;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        ini_set('memory_limit', '1G');
        set_time_limit(120);
        $conditions = $this->utilService->getParamsAsArray($request);
        if (isset($conditions['DTENTRVENDA'])){
            $this->conditionsMake($conditions);
            if($conditions['TIPORELATORIO'] == 'S'){
                $result = $this->RelDecontosTipoConsumiService->getDescConsuSint($conditions);
            }else{
                $result = $this->RelDecontosTipoConsumiService->getDescConsuAnali($conditions);
            }
            $response->addDataSet(new DataSet("vnd55017_relDecontosTipoConsumidor", $result));
        }else{
            $response = [];
        }
        return $response;
    }

    public function conditionsMake(&$conditions){
        if (isset($conditions['CDFILIAL'])){
            if(is_array($conditions['CDFILIAL'])){
                $conditions['TCDFILIAL'] = 'F';
                $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
            }
            else{
                $conditions['CDFILIAL'] = null;
                $conditions['TCDFILIAL'] = 'T';
            }
        }else{
            $conditions['CDFILIAL'] = null;
            $conditions['TCDFILIAL'] = 'T';
        }
        if (isset($conditions['CDCLIENTE'])){
            if(is_array($conditions['CDCLIENTE'])){
                $conditions['TCDCLIENTE'] = 'F';
                $conditions['CDCLIENTE'] = implode('_', $conditions['CDCLIENTE']);
            }
            else{
                $conditions['CDCLIENTE'] = NULL;
                $conditions['TCDCLIENTE'] = 'T';
            }
        }else{
            $conditions['CDCLIENTE'] = NULL;
            $conditions['TCDCLIENTE'] = 'T';
        }
        if (isset($conditions['CDCONSUMIDOR'])){
            if(is_array($conditions['CDCONSUMIDOR'])){
                $conditions['TCDCONSUMIDOR'] = 'F';
                $conditions['CDCONSUMIDOR'] = implode('_', $conditions['CDCONSUMIDOR']);
            }
            else{
                $conditions['CDCONSUMIDOR'] = NULL;
                $conditions['TCDCONSUMIDOR'] = 'T';
            }
        }else{
            $conditions['CDCONSUMIDOR'] = NULL;
            $conditions['TCDCONSUMIDOR'] = 'T';
        }
        if (isset($conditions['CDTIPOCONS'])){
            if(is_array($conditions['CDTIPOCONS'])){
                $conditions['TCDTIPOCONS'] = 'F';
                $conditions['CDTIPOCONS'] = implode('_', $conditions['CDTIPOCONS']);
            }
            else{
                $conditions['CDTIPOCONS'] = NULL;
                $conditions['TCDTIPOCONS'] = 'T';
            }
        }else{
            $conditions['CDTIPOCONS'] = NULL;
            $conditions['TCDTIPOCONS'] = 'T';
        }
        $conditions['DTVENDAINI'] = $conditions['DTENTRVENDA'][0];
        $conditions['DTVENDAFIN'] = $conditions['DTENTRVENDA'][1];
    }
    
}