<?php
namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities\Util;
use Teknisa\MAN\Utilities\Resposta; 

class ExpImpNfceService {
    
    public $entityManager;
    
   	public function __construct(\Doctrine\ORM\EntityManager $entityManager, Util $util)  {
		$this->entityManager = $entityManager;
		$this->util = $util;
	}
	
	public function executarQuery($query, $params) {
	    
	    $retorno = new Resposta();
	    
	    $retorno->setParameters($params);
	    try {
	        $resultado = $this->entityManager->getConnection()->fetchAll($query, $params);
	        $retorno->setResult($resultado);
	        $retorno->setMessage("Query executada com sucesso. Linhas retornadas: ".$retorno->getLinhasResult());
	        $retorno->setStatus(Resposta::SUCESSO);
	    } catch (\Exception $e){
            $retorno->setMessage($e->getMessage());
            $retorno->setError(true);
            $retorno->setStatus(Resposta::ERRO);
        }
        
        return $retorno;
        
	}
	
	//nao sera mais necessario
	//const BUSCAR_URLCHAVE = "SELECT WSSITEUFQRCODENFC FROM WEBSERVICE WHERE SGESTADO = :SGESTADO AND IDSERVICO = :IDSERVICO AND IDAMBIENTE = :IDAMBIENTE";
	
	const BUSCAR_NOTAS = "SELECT * FROM (SELECT IDCHECK, CDFILIAL, CDCAIXA, CDLOJA, NRSEQVENDA, DTENTRVENDA, NRACESSONFCE,
       CDSERIE, IDTPEMISVEND, NRNOTAFISCALCE, IDSITUVENDA, IDTPAMBNFCE, NRPROTOCOLONFCE,
       DTHRPROTOCONFCE, IDSTATUSNFCE, NRINSJURIEST, DTHRPROTOCOCANC, DSRAZAOCANCNFCE, NRPROTOCOLOCANC, NRCERTDIGNFCE,
       DSARQXMLNFCE, DSARQXMLCANCNFCE, DSQRCODENFCE, WSSITEUFQRCODENFC, CDVERSAOXMLNFCE, IDORIGEMVENDA, CDINSCESTA, CDIDTOKENPROD, CDIDTOKENHOMO,
       CDCODSCONSPROD, CDCODSCONSHOMO, NMRAZSOCFILI, NRINSJURFILI, DTABERTUR, VRTOTALVENDA
  FROM (SELECT *
          FROM (SELECT VE.*, ROWNUM LINHA
                  FROM (SELECT 'N' AS IDCHECK, VE.CDFILIAL, VE.CDCAIXA, VE.CDLOJA, VE.NRSEQVENDA, TO_CHAR(VE.DTENTRVENDA, 'DD/MM/YYYY') DTENTRVENDA, VE.NRACESSONFCE,
                               NVL(VE.CDSERIENFCE,VE.CDSERIESAT) AS CDSERIE, VE.IDTPEMISVEND, VE.NRNOTAFISCALCE, VE.IDSITUVENDA, VE.IDTPAMBNFCE, VE.NRPROTOCOLONFCE,
                               VE.DTHRPROTOCONFCE, VE.IDSTATUSNFCE, VE.NRINSJURIEST, VE.DTHRPROTOCOCANC, VE.DSRAZAOCANCNFCE, VE.NRPROTOCOLOCANC, PV.NRCERTDIGNFCE,
                               NVL(VE.DSARQXMLNFCE, AX.DSARQXMLNFCE) AS DSARQXMLNFCE, VE.DSARQXMLCANCNFCE, VE.DSQRCODENFCE, WS.WSSITEUFQRCODENFC, PV.CDVERSAOXMLNFCE, VE.IDORIGEMVENDA,
                               FI.CDINSCESTA, PV.CDIDTOKENPROD, PV.CDIDTOKENHOMO, PV.CDCODSCONSPROD, PV.CDCODSCONSHOMO, FI.NMRAZSOCFILI, FI.NRINSJURFILI, VE.DTABERTUR, VE.VRTOTVENDA AS VRTOTALVENDA
                          FROM PARAVEND PV, VENDA VE, WEBSERVICE WS, ARQXMLNFCESAT AX,(SELECT DISTINCT CDFILIAL, CDCAIXA
                                                         FROM V_FILIALLOJACAIXA F
                                                        WHERE ((INSTR(:P_CDFILIAL, F.CDFILIAL) <> 0) OR (:P_TCDFILIAL = 'T'))
                                                          AND ((INSTR(:P_CDCAIXA, F.CDFILIAL||F.CDCAIXA) <> 0) OR (:P_TCDCAIXA = 'T'))) FC, FILIAL FI 
                         WHERE FC.CDFILIAL = FI.CDFILIAL
                           AND FC.CDFILIAL = PV.CDFILIAL
                           AND FC.CDFILIAL = VE.CDFILIAL
                           AND FC.CDCAIXA = VE.CDCAIXA
                           AND AX.CDFILIAL(+)   = VE.CDFILIAL
                           AND AX.CDCAIXA(+)    = VE.CDCAIXA
                           AND AX.NRSEQVENDA(+) = VE.NRSEQVENDA
                           AND WS.SGESTADO(+) = VE.SGESTADO
                           AND WS.IDSERVICO(+) = 'NFC'
                           AND WS.IDAMBIENTE(+) = VE.IDTPAMBNFCE
                           AND VE.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIM) VE
                 WHERE ((INSTR(:NRNOTAFISCALCE, VE.NRNOTAFISCALCE) <> 0) OR (:NRNOTAFISCALCE = 'T'))
                   AND ((VE.IDTPEMISVEND = 'N') OR (VE.IDTPEMISVEND = 'S'))
                   AND (INSTR(:P_IDSTATUSNFCE, VE.IDSTATUSNFCE) <> 0)
                   AND (VE.DSARQXMLNFCE IS NOT NULL)
                   AND VE.IDTPAMBNFCE = :IDTPAMBNFCE
                ORDER BY VE.DTENTRVENDA, VE.CDFILIAL, VE.CDCAIXA, VE.NRSEQVENDA) X
          ORDER BY LINHA) REG ) WHERE (CDFILIAL||CDCAIXA||NRSEQVENDA||NRACESSONFCE||CDSERIE||NRNOTAFISCALCE||IDTPAMBNFCE||IDTPEMISVEND||IDSITUVENDA like :ALLFIEDLS  OR :ALLFIEDLS = 'T' )";   
}